/***************************Copyright-DO-NOT-REMOVE-THIS-LINE**
 * CONDOR Copyright Notice
 *
 * See LICENSE.TXT for additional notices and disclaimers.
 *
 * Copyright (c)1990-2004 CONDOR Team, Computer Sciences Department,
 * University of Wisconsin-Madison, Madison, WI.  All Rights Reserved.
 * No use of the CONDOR Software Program Source Code is authorized
 * without the express consent of the CONDOR Team.  For more information
 * contact: CONDOR Team, Attention: Professor Miron Livny,
 * 7367 Computer Sciences, 1210 W. Dayton St., Madison, WI 53706-1685,
 * (608) 262-0856 or miron@cs.wisc.edu.
 *
 * U.S. Government Rights Restrictions: Use, duplication, or disclosure
 * by the U.S. Government is subject to restrictions as set forth in
 * subparagraph (c)(1)(ii) of The Rights in Technical Data and Computer
 * Software clause at DFARS 252.227-7013 or subparagraphs (c)(1) and
 * (2) of Commercial Computer Software-Restricted Rights at 48 CFR
 * 52.227-19, as applicable, CONDOR Team, Attention: Professor Miron
 * Livny, 7367 Computer Sciences, 1210 W. Dayton St., Madison,
 * WI 53706-1685, (608) 262-0856 or miron@cs.wisc.edu.
****************************Copyright-DO-NOT-REMOVE-THIS-LINE**/

// Implementation of ErrorStatus class.

#include "trigger_common.h"

#include <iostream>

#include "ErrorStatus.h"

//-------------------------------------------------------------------------
void
ErrorStatus::operator+=(const ErrorStatus &other)
{
	if ( other._status > _status ) {
		_ec = other._ec;
	}

	_status = StatusCombine(_status, other._status);
}

//-------------------------------------------------------------------------
string
ErrorStatus::Value() const
{
	string result;
 
	switch ( _status ) {
	case StatusInvalid:
		result = "StatusInvalid";
		break;

	case StatusOk:
		result = "StatusOk";
		break;

	case StatusFailed:
		result = "StatusFailed";
		break;

	case StatusWarn:
		result = "StatusWarn";
		break;

	case StatusCancel:
		result = "StatusCancel";
		break;

	case StatusWarnCancel:
		result = "StatusWarnCancel";
		break;

	default:
		result = "illegal status value";
		break;
	}

	return result;
}

//-------------------------------------------------------------------------
ostream&
operator<<(ostream& os, const ErrorStatus& status)
{
	os << status.Value() << ", " << status.GetErrorCode();
	return os;
}

//-------------------------------------------------------------------------
StatusVal
ErrorStatus::StatusCombine(StatusVal status1, StatusVal status2)
{
	StatusVal result(StatusOk);

	if ( (status1 == StatusInvalid) || (status2 == StatusInvalid) ) {
		result = StatusInvalid;

	} else if ( (status1 == StatusFailed) || (status2 == StatusFailed) ) {
		result = StatusFailed;

	} else if ( StatIsCancel(status1) || StatIsCancel(status2) ) {
		if ( StatIsWarn(status1) || StatIsWarn(status2) ) {
			result = StatusWarnCancel;
		} else {
			result = StatusCancel;
		}

	} else if ( StatIsWarn(status1) || StatIsWarn(status2) ) {
		result = StatusWarn;

	} else if ( (status1 == StatusOk) && (status2 == StatusOk) ) {
		result = StatusOk;

	} else {
		result = StatusInvalid;
	}

	return result;
}

/*============================================================================*/
