/***************************Copyright-DO-NOT-REMOVE-THIS-LINE**
 * CONDOR Copyright Notice
 *
 * See LICENSE.TXT for additional notices and disclaimers.
 *
 * Copyright (c)1990-2004 CONDOR Team, Computer Sciences Department,
 * University of Wisconsin-Madison, Madison, WI.  All Rights Reserved.
 * No use of the CONDOR Software Program Source Code is authorized
 * without the express consent of the CONDOR Team.  For more information
 * contact: CONDOR Team, Attention: Professor Miron Livny,
 * 7367 Computer Sciences, 1210 W. Dayton St., Madison, WI 53706-1685,
 * (608) 262-0856 or miron@cs.wisc.edu.
 *
 * U.S. Government Rights Restrictions: Use, duplication, or disclosure
 * by the U.S. Government is subject to restrictions as set forth in
 * subparagraph (c)(1)(ii) of The Rights in Technical Data and Computer
 * Software clause at DFARS 252.227-7013 or subparagraphs (c)(1) and
 * (2) of Commercial Computer Software-Restricted Rights at 48 CFR
 * 52.227-19, as applicable, CONDOR Team, Attention: Professor Miron
 * Livny, 7367 Computer Sciences, 1210 W. Dayton St., Madison,
 * WI 53706-1685, (608) 262-0856 or miron@cs.wisc.edu.
****************************Copyright-DO-NOT-REMOVE-THIS-LINE**/

#include "trigger_common.h"

#include <stdio.h>
#include <errno.h>
#include <iostream>

#include "Output.h"

Output *Output::instance = NULL;

//-------------------------------------------------------------------------
Output *
Output::GetInstance()
{
	if ( !instance ) {
		instance = new Output();
	}

	return instance;
}

//-------------------------------------------------------------------------
void
Output::MsgOut(Verbosity msgType, string msg, string srcFile,
		int srcLine) const
{
	if ( verbosity >= msgType ) {
		ostream &ostr = msgType == VERBOSITY_ERROR ? cerr : cout;

		if ( msgType == VERBOSITY_ERROR ) {
			ostr << "ERROR: ";
		} else if ( msgType == VERBOSITY_WARN ) {
			ostr << "Warning: ";
		}

		ostr << msg << endl;

		if ( (msgType == VERBOSITY_ERROR ||
				msgType == VERBOSITY_WARN) && errno != 0 ) {
			perror("");
			errno = 0;
		}

		if ( srcLine > 0 ) {
			ostr << "    at " << srcFile << " line " << srcLine << endl;
		}
	}
}
