/***************************Copyright-DO-NOT-REMOVE-THIS-LINE**
 * CONDOR Copyright Notice
 *
 * See LICENSE.TXT for additional notices and disclaimers.
 *
 * Copyright (c)1990-2004 CONDOR Team, Computer Sciences Department,
 * University of Wisconsin-Madison, Madison, WI.  All Rights Reserved.
 * No use of the CONDOR Software Program Source Code is authorized
 * without the express consent of the CONDOR Team.  For more information
 * contact: CONDOR Team, Attention: Professor Miron Livny,
 * 7367 Computer Sciences, 1210 W. Dayton St., Madison, WI 53706-1685,
 * (608) 262-0856 or miron@cs.wisc.edu.
 *
 * U.S. Government Rights Restrictions: Use, duplication, or disclosure
 * by the U.S. Government is subject to restrictions as set forth in
 * subparagraph (c)(1)(ii) of The Rights in Technical Data and Computer
 * Software clause at DFARS 252.227-7013 or subparagraphs (c)(1) and
 * (2) of Commercial Computer Software-Restricted Rights at 48 CFR
 * 52.227-19, as applicable, CONDOR Team, Attention: Professor Miron
 * Livny, 7367 Computer Sciences, 1210 W. Dayton St., Madison,
 * WI 53706-1685, (608) 262-0856 or miron@cs.wisc.edu.
****************************Copyright-DO-NOT-REMOVE-THIS-LINE**/

#ifndef _classad_triggers_h_
#define _classad_triggers_h_

#include <string>

#include "ErrorStatus.h"
#include "Output.h"

#define VERSION "0.9.0"

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

class Parameters {
public:
	/**
	 * Constructor.
	 * @param Argument count.
	 * @param Argument list.
	 */
	Parameters(int argc, char **argv);

	/**
	 * Get the error status of this object.
	 * @return ErrorStatus of this object.
	 */
	const ErrorStatus &ObjectStatus() const { return objectStatus; }

	bool		run;
	string		preProcAdsInFile;
	string		actionAdsOutFile;
	string		stateAdsInFile;
	string		stateAdsOutFile;
	string		stateDefAdsFile;
	string		statusAdsFile;
	string		statusPreFile;
	string		triggerAdsFile;
	Output::Verbosity	verbosity;

private:
	/**
	 * Find out whether the current parameter is the given parameter; to
	 * be used on parameters that have no associated value.
	 * @param The parameter name.
	 * @return True iff the current param has the given name.
	 */
	bool getParamWithoutValue(string paramName) const;

	/**
	 * Find out whether the current parameter is the given parameter; if
	 * so, get the parameter value.
	 * @param The parameter name.
	 * @param A string reference to hold the param value.
	 * @return True iff the current param has the given name.
	 */
	bool getParamWithValue(string paramName, string &paramValue);

	ErrorStatus	objectStatus;

	int			tmpArgc;
	char **		tmpArgv;
	int			index;
};

#endif /* _classad_triggers_h_ */
